from util.excel_data import OperatorExcel
import copy


class TestData:

    def __init__(self, file=None):
        api_datas = OperatorExcel(file).get_all_case()
        scene_datas = OperatorExcel(file).get_scene_case()
        self.title, self.case_data = api_datas[0], api_datas[1:]
        self.scene_title, self.scene_data = scene_datas[0], scene_datas[1:]

    def get_data(self):
        case_datas = []
        for case in self.case_data:
            case_dict = {}
            for index, title in enumerate(self.title):
                case_dict[title] = case[index]
            case_datas.append(case_dict)
        return case_datas

    def get_scene_data(self):
        scene_datas = []
        for case in self.scene_data:
            case_dict = {}
            for index, title in enumerate(self.scene_title):
                case_dict[title] = case[index]
            scene_datas.append(case_dict)

        for scene in scene_datas:
            if scene['scene_case']:
                a = copy.deepcopy(scene['scene_case'])
                tmp_case = copy.deepcopy(a.split('-'))
                tmp_cases = []
                for c in tmp_case:
                    for cc in self.get_data():
                        if c == cc['name']:
                            tmp_cases.append(cc)
                scene['scene_case'] = tmp_cases
        return scene_datas


if __name__ == '__main__':
    TestData().get_scene_data()
