"""
执行时需要继承Testunner这个类
不允许重载__init__函数
"""
from base.case_runner import TestRunner
from base.case_runner import excel_driver
import copy


# 到货单创建参数修改
def inbound_asn_edit(case, m_res):
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['sku_id'] = ''
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['pack_id'] = ''
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['location_id'] = ''
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['sku__code'] = ''
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['sku__name'] = ''
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['pack__code'] = ''
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['pack__name'] = ''
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['location__code'] = ''
    case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['location__name'] = ''


# 入库表单头处理
def order_replace(case, m_res):
    tmp_data_header = copy.deepcopy(m_res['header'])
    tmp_data_lines = copy.deepcopy(m_res['lines']['rows'][0])
    mod_feild = ['owner_id', 'order_time', 'type', 'id',
                 'type_label', 'insert_date', 'warehouse__code',
                 'owner__code', 'warehouse__code', 'come_from_label',
                 'come_from', 'asn_no', 'warehouse__name', 'bill_status',
                 'bill_status_label', 'receipt_no']
    for i in mod_feild:
        if i in tmp_data_lines:
            case.request_data['selectedRows'][0]['currentData'][i] = tmp_data_lines[i]
            # case.request_data['aux'][i] = tmp_data_header[i]
        if i in tmp_data_header:
            case.request_data['aux'][i] = tmp_data_header[i]
        if i == 'id':
            case.request_data['selectedRows'][0]['currentData'][i] = tmp_data_header[i]
            case.request_data['aux'][i] = tmp_data_header[i]
    case.request_data['selectedRows'][0]['originalData'] = case.request_data['selectedRows'][0]['currentData']


def save_parameter_replace(case, m_res):
    tmp_data_header = copy.deepcopy(m_res['header'])
    for h in tmp_data_header.keys():
        if h in case.request_data['aux']:
            case.request_data['aux'][h] = tmp_data_header[h]
        if h in case.request_data['selectedRows'][0]['currentData']:
            case.request_data['selectedRows'][0]['currentData'][h] = tmp_data_header[h]
    case.request_data['selectedRows'][0]['originalData'] = case.request_data['selectedRows'][0]['currentData']


# 上架参数处理
def execute_putaway_order_data(case, m_res):
    tmp_data_header = copy.deepcopy(m_res['header'])
    tmp_data_lines = copy.deepcopy(m_res['lines']['rows'][0])
    for h in tmp_data_header.keys():
        if h in case.request_data['aux']:
            case.request_data['aux'][h] = tmp_data_header[h]
        if h in case.request_data['selectedRows'][0]['header']['currentData']:
            case.request_data['selectedRows'][0]['header']['currentData'][h] = tmp_data_header[h]
    for r in tmp_data_lines.keys():
        case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData'][r] = tmp_data_lines[r]
    aaa = case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']
    case.request_data['selectedRows'][0]['header']['originalData'] = case.request_data['selectedRows'][0]['header']['currentData']
    case.request_data['selectedRows'][0]['lines']['rows'][0]['originalData'] = aaa
    case.request_data['selectedRows'][0]['lines']['currentRow']['currentData'] = aaa
    case.request_data['selectedRows'][0]['lines']['currentRow']['originalData'] = aaa


# 生成上架单参数处理
def gen_pk_parameter(case, m_res):
    if m_res:
        for pk_info in m_res:
            for t_keys in pk_info.keys():
                if t_keys in case.request_data['selectedRows'][0]['currentData'].keys():
                    case.request_data['selectedRows'][0]['currentData'][t_keys] = pk_info[t_keys]

        aaa = case.request_data['selectedRows'][0]['currentData']
        case.request_data['selectedRows'][0]['originalData'] = aaa

        case.request_data['aux']['selection'][0]['currentData'] = aaa
        case.request_data['aux']['selection'][0]['originalData'] = aaa
        case.request_data['aux']['rows'][0]['currentData'] = aaa
        case.request_data['aux']['rows'][0]['originalData'] = aaa


@excel_driver('D:/Gitee/test_data/testcase.xlsx')
class GQTest(TestRunner):
    # 重写用例执行前的方法
    def before_parameter(self, case, mid_res):
        """
            case-- 用例对象，可通过case.name这里的名字与excel中的字段对应即可
            mid_res-- 保存的中间结果
        """
        if case.name == '增加库位':
            case.request_data['selectedRows'][0]['header']['currentData']['code'] = 'H-1-1-008'
            case.request_data['selectedRows'][0]['header']['currentData']['refer_code'] = 'H-1-1-008'
            case.request_data['selectedRows'][0]['header']['currentData']['name'] = 'H-1-1-008'
        elif '到货单创建' in case.name:
            pass
        elif case.name in ['提交到货单', '确认到货单', '删除到货单', '删除到货单异常']:
            order_replace(case, mid_res['sub_data'])
        elif case.name in ['整单收货', '确认完成收货', '生成上架单', '撤回到货单', '整单回转收货']:
            save_parameter_replace(case, mid_res['order_info'])
        elif '到货单创建' in case.name:
            case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['location_id'] = \
                mid_res.get('location')['id']
            case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['location__code'] = \
                mid_res.get('location')['code']
            case.request_data['selectedRows'][0]['lines']['rows'][0]['currentData']['location__name'] = \
                mid_res.get('location')['name']
        elif case.name in ['上架单查询', '发放上架', '执行上架', '取消上架']:
            if case.name == '上架单查询':
                putaway_msg = mid_res.get('putaway_msg')
                mid_res['putaway_num'] = putaway_msg[-15:]
                case.request_data['keyword']['value'] = putaway_msg[-15:]
            elif case.name == '执行上架':
                execute_putaway_order_data(case, mid_res['execute_putaway_data'])
            else:
                order_replace(case, mid_res['putaway_info'])
        elif case.name in ['分配库存']:
            save_parameter_replace(case, mid_res['output_order_info'])
        elif case.name in ['生成拣选单']:
            gen_pk_parameter(case, mid_res['pk_info'])


if __name__ == '__main__':
    GQTest().run_test()
